<template>
    <q-modal
      :value="isActive"
      minimized
      @hide="$emit('close')"
    >
      <div class="q-pa-md" v-if="method">
        <div class="q-title">Edit {{method.name}} method</div>

        <component
          :is="methodComponent"
          :method="method"
          class="q-mt-md"
        />
      </div>
    </q-modal>
</template>

<script>
    import listMethod from './method/listMethod';
    import actionMethod from './method/actionMethod';

    export default {
      name: 'methodEditor',
      props: {
        method: {
          type: Object,
        },
      },
      computed: {
        isActive() {
          return !!this.method;
        },
        methodComponent() {
          return {
            list: listMethod,
            action: actionMethod,
          }[this.method.type];
        },
      },
    };
</script>
